/*
 * qbuffer.h
 *
 *  Created on: Oct 25, 2012
 *      Author: root
 */

#ifndef QBUFFER_H_
#define QBUFFER_H_

#include "qstdinc.h"
#include "qstdvectors.h"

class QBuffer
{
public:
	/* Construction */
	QBuffer();
	QBuffer(uint8_t*, int);
	virtual ~QBuffer();

	/* Control data indirect */
	void Add(uint8_t nData);
	void Add(uint8_t* pData, int nSize);
	void Add(QByteArray* pData);
	void Add(QBuffer* pData);

	bool Remove(int nFrom, int nCount, QByteArray* pData);
	void Clean();

	inline uint8_t* GetData() { return m_pData; }
	inline int GetSize() { return m_nSize; }
	void Resize(int nNewSize) { Allocate(nNewSize); m_nSize = nNewSize; }

	/* Members */
protected:
	uint8_t*		m_pData;
	int				m_nAllocated;
	int				m_nSize;

	void FreeSpace();
	void Allocate(int);
	inline void CheckSpace(int nRequired) { int nNewSize = m_nSize + nRequired; if (nNewSize >= m_nAllocated) Allocate(nNewSize); }
};

#endif /* SOCKDATA_H_ */
